Bug 731966 - Review Request: openstack-glance - OpenStack Image Service
Review Request: openstack-glance - OpenStack Image Service
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Steven Dake
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 707199
  Show dependency treegraph
 
Reported: 2011-08-19 05:58 EDT by Mark McLoughlin
Modified: 2016-04-26 11:31 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-08-23 03:34:02 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
sdake: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Mark McLoughlin 2011-08-19 05:58:45 EDT
This is OpenStack's Image Service. It is written in python, so closely follows the python packaging guidelines. There are two sub-packages - python-glance and openstack-glance-doc - as well as the main package.

It is required by openstack-nova, see bug #707199

Spec URL: https://raw.github.com/markmc/openstack-fedora-specs/014f8941/SPECS/openstack-glance.spec
SRPM URL: http://koji.fedoraproject.org/koji/getfile?taskID=3279387&name=openstack-glance-2011.3-0.1.987bzr.fc16.src.rpm
Scratch Koji Build URL: http://koji.fedoraproject.org/koji/taskinfo?taskID=3279386
Fedora 16 yum repo URL: http://repos.fedorapeople.org/repos/markmc/openstack/fedora-openstack.repo

Description:
OpenStack Image Service (code-named Glance) provides discovery, registration,
and delivery services for virtual disk images. The Image Service API server
provides a standard REST interface for querying information about virtual disk
images stored in a variety of back-end stores, including OpenStack Object
Storage. Clients can register new virtual disk images with the Image Service,
query for information on publicly available disk images, and use the Image
Service's client library for streaming virtual disk images.
Comment 1 Steve Traylen 2011-08-19 13:58:58 EDT
Hi,

Very happy to review this, the obvious thing that needs some work before this can really
commence is the adaption to systemd.

http://fedoraproject.org/wiki/Packaging:Guidelines#Systemd

Steve.
Comment 2 Steven Dake 2011-08-21 13:47:01 EDT
Mark,

I'll provide a complete review for you below.

[FAIL] rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.

[root@beast SRPMS]# rpmlint openstack-glance-2011.3-0.1.987bzr.fc15.src.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[root@beast noarch]# rpmlint openstack-glance-doc-2011.3-0.1.987bzr.fc15.noarch.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[root@beast noarch]# rpmlint python-glance-2011.3-0.1.987bzr.fc15.noarch.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

[root@beast noarch]# rpmlint openstack-glance-2011.3-0.1.987bzr.fc15.noarch.rpm
openstack-glance.noarch: W: non-standard-uid /var/log/glance glance
openstack-glance.noarch: W: non-standard-uid /var/run/glance glance
openstack-glance.noarch: W: non-standard-uid /var/lib/glance glance
openstack-glance.noarch: W: log-files-without-logrotate /var/log/glance
openstack-glance.noarch: W: no-manual-page-for-binary glance-scrubber
openstack-glance.noarch: W: no-manual-page-for-binary glance-cache-pruner
openstack-glance.noarch: W: no-manual-page-for-binary glance-registry
openstack-glance.noarch: W: no-manual-page-for-binary glance-manage
openstack-glance.noarch: W: no-manual-page-for-binary glance-cache-prefetcher
openstack-glance.noarch: W: no-manual-page-for-binary glance-upload
openstack-glance.noarch: W: no-manual-page-for-binary glance-control
openstack-glance.noarch: W: no-manual-page-for-binary glance-api
openstack-glance.noarch: W: no-manual-page-for-binary glance-cache-reaper
openstack-glance.noarch: W: no-manual-page-for-binary glance
openstack-glance.noarch: W: missing-lsb-keyword Provides in /etc/rc.d/init.d/openstack-glance-registry
openstack-glance.noarch: W: incoherent-subsys /etc/rc.d/init.d/openstack-glance-registry $prog
openstack-glance.noarch: W: missing-lsb-keyword Provides in /etc/rc.d/init.d/openstack-glance-api
openstack-glance.noarch: W: incoherent-subsys /etc/rc.d/init.d/openstack-glance-api $prog
1 packages and 0 specfiles checked; 0 errors, 18 warnings.


(BLOCKER) Steve Traylen recommends that the package be ported to systemd.  This is not currently required by Fedora or reviewers to enforce this activity.  The init scripts are not LSB complaint resulting in many errors.  Before this package can be approved, either the init scripts must be made lsb compliant, or the package should adopt systemd.  Note systemd may become mandatory in future versions of Fedora, and packaging today may save you work tomorrow.  If you need technical help, try contactng Angus Salkeld - he just did some systemd work for a few other projects we maintain.

NEEDSWORK -> After this package achieves fedora-review-+ please file a bugzilla to have the package maintainer work with upstream to create man pages for the missing man pages for binaries.


]PASS] The package must be named according to the Package Naming Guidelines .
[PASS] The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. 
[PASS] The package must meet the Packaging Guidelines .
[PASS] The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[PASS] The License field in the package spec file must match the actual license.

[PASS] If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

NEEDSWORK -> After fedora-review-+, please file a bug with upstream requesting the upstream to release a license file in the software distribution.  Once that license file is distributed in the binary, please modify the spec file to distribute this binary.  This is standard practice for open source projects.

[PASS] The spec file must be written in American English. [5]
[PASS] The spec file for the package MUST be legible. [6]

NEEDSWORK -> I'd recommend removing the %{shortname} macro and replacing it with glance.  It makes reading the spec file confusing, and someone will end up doing this in the future anyway.

[PASS]: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

NEEDSWORK -> Generally nightly builds should not be used for releasing Fedora software.  Many upstream projects remove upstream nightly build files in short periods of time, making it impossible to validate the upstream sources.  Is it possible to use a stable or unstable release version?


[PASS]: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]

http://koji.fedoraproject.org/koji/taskinfo?taskID=3290241

[ N/A] If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
[PASS] All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[PASS] The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
[ N/A] Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
[PASS] Packages must NOT bundle copies of system libraries.[11]
[ N/A] If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]
[PASS]: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]
[PASS]: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)[14]
[PASS]: Permissions on files must be set properly. Executables should be set with executable permissions, for example. [15]
[PASS] Each package must consistently use macros. [16]

Macros are consistently used, but I'd recommend against using the shortname macro - it is confusing and adds no value.

The source1 and Source2 init script definitions use %{name} which is confusing - a maintainer has to figure out what name means.  Better not to use a macro for this case.  These are just my opinions, so take them for what they are worth.

[PASS] The package must contain code, or permissable content. [17]
[PASS] Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
[PASS] If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
[ N/A] Header files must be in a -devel package. [19]
[ N/A] Static libraries must be in a -static package. [20]
[ N/A] If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]
[ N/A] In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release} [21]
[ N/A] Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
[ N/A] Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [22]
[PASS] Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [23]
MUST: All filenames in rpm packages must be valid UTF-8.
Comment 3 Steven Dake 2011-08-21 13:50:11 EDT
Summary of MUST review items.  One issue blocks fedora-review+, other issues should be considered by the packager.

(BLOCKER) Steve Traylen recommends that the package be ported to systemd.  This
is not currently required by Fedora or reviewers to enforce this activity.  The
init scripts are not LSB complaint resulting in many errors.  Before this
package can be approved, either the init scripts must be made lsb compliant, or
the package should adopt systemd.  Note systemd may become mandatory in future
versions of Fedora, and packaging today may save you work tomorrow.  If you
need technical help, try contactng Angus Salkeld - he just did some systemd
work for a few other projects we maintain.

NEEDSWORK -> After this package achieves fedora-review-+ please file a bugzilla
to have the package maintainer work with upstream to create man pages for the
missing man pages for binaries.

NEEDSWORK -> After fedora-review-+, please file a bug with upstream requesting
the upstream to release a license file in the software distribution.  Once that
license file is distributed in the binary, please modify the spec file to
distribute this binary.  This is standard practice for open source projects.

NEEDSWORK -> I'd recommend removing the %{shortname} macro and replacing it
with glance.  It makes reading the spec file confusing, and someone will end up
doing this in the future anyway.

NEEDSWORK -> Generally nightly builds should not be used for releasing Fedora
software.  Many upstream projects remove upstream nightly build files in short
periods of time, making it impossible to validate the upstream sources.  Is it
possible to use a stable or unstable release version?

Macros are consistently used, but I'd recommend against using the shortname
macro - it is confusing and adds no value.

The source1 and Source2 init script definitions use %{name} which is confusing
- a maintainer has to figure out what name means.  Better not to use a macro
for this case.  These are just my opinions, so take them for what they are
worth.
Comment 4 Steven Dake 2011-08-21 13:57:33 EDT
Python package review:

Please see:
http://fedoraproject.org/wiki/Packaging:Python

To build a package containing python2 files, you need to have

BuildRequires: python2-devel


[PASS]    Must: Python eggs must be built from source. They cannot simply drop an egg from upstream into the proper directory. (See prebuilt binaries Guidelines for details)
[PASS]    Must: Python eggs must not download any dependencies during the build process.
[ N/A]    Must: When building a compat package, it must install using easy_install -m so it won't conflict with the main package.
n N/A]    Must: When building multiple versions (for a compat package) one of the packages must contain a default version that is usable via "import MODULE" with no prior setup.
[PASS]    Should: A package which is used by another package via an egg interface should provide egg info.
Comment 5 Mark McLoughlin 2011-08-22 10:54:42 EDT
Thanks for the review Steven!

(In reply to comment #2)

> [root@beast noarch]# rpmlint openstack-glance-2011.3-0.1.987bzr.fc15.noarch.rpm
> openstack-glance.noarch: W: non-standard-uid /var/log/glance glance
> openstack-glance.noarch: W: non-standard-uid /var/run/glance glance
> openstack-glance.noarch: W: non-standard-uid /var/lib/glance glance

Okay, this just means that these dirs are (a) owned by the glance user and
(b) the glance user is dynamically allocated

I've just followed the guidelines here:

  http://fedoraproject.org/wiki/Packaging:UsersAndGroups

Which suggest allocating the uids and gids dynamically, but I've just now
filed a static uidgid allocation request which would shut the warning up:

  https://bugzilla.redhat.com/732442

> openstack-glance.noarch: W: log-files-without-logrotate /var/log/glance

I'll add a bugzilla to track this once. It's just a warning and the logs
aren't huge

> openstack-glance.noarch: W: no-manual-page-for-binary glance-scrubber
> ...

Will file a bugzilla for these too

> openstack-glance.noarch: W: missing-lsb-keyword Provides in /etc/rc.d/init.d/openstack-glance-registry

See:

   http://fedoraproject.org/wiki/Packaging:SysVInitScript

   In Fedora, a # Provides: line listing the name of the service that the
   initscript starts is not needed as the name of the service is implicitly
   Provided.

I've add an empty Provides: line to work around the warning, though.

> openstack-glance.noarch: W: incoherent-subsys /etc/rc.d/init.d/openstack-glance-registry $prog

This turns out to be rpmlint getting confused by:

  suffix="registry"
  prog="openstack-glance-$suffix"

instead of:

  suffix=registry
  prog=openstack-glance-$suffix

I've changed it to the latter

> (BLOCKER) Steve Traylen recommends that the package be ported to systemd.  This
> is not currently required by Fedora or reviewers to enforce this activity.

Right. I'd prefer to defer switching to systemd until after the package
has been included.

I'll file a bugzilla to remind us to do this though

> NEEDSWORK -> After fedora-review-+, please file a bug with upstream requesting
> the upstream to release a license file in the software distribution

Will do

> NEEDSWORK -> I'd recommend removing the %{shortname} macro

Yeah, I'm not a big fan of the macro either - done now.

> NEEDSWORK -> Generally nightly builds should not be used for releasing Fedora
> software.  Many upstream projects remove upstream nightly build files in short
> periods of time, making it impossible to validate the upstream sources.  Is it
> possible to use a stable or unstable release version?

Fair point. The idea is to switch to the official Diablo release
tarballs once it comes out in September. See:

  http://wiki.openstack.org/DiabloReleaseSchedule

I'll also plan on switching to the diablo-4 milestone release when that
comes out later this week, and stick with that until we get the official
release (or, indeed, a release candidate).

I'm not too worried about the logevity of the nightly snapshots; they
have them archived since November 2010 currently.

> The source1 and Source2 init script definitions use %{name} which is confusing
> - a maintainer has to figure out what name means.  Better not to use a macro
> for this case.

Okay, done.

(In reply to comment #4)
> Python package review:
>
> Please see:
> http://fedoraproject.org/wiki/Packaging:Python
>
> To build a package containing python2 files, you need to have
>
> BuildRequires: python2-devel

This came up in bug #731980 too. The question there is why we need the
-devel package at all?

BR: python2-devel vs BR: python-devel isn't such a big deal, except
for future-proofing. Currently, python-devel Provides: python2-devel.

I've just sent a mail to the python SIG asking for their clarification. Will update based on that.
Comment 7 Steven Dake 2011-08-22 11:53:57 EDT
Mark,

The updated package looks good and I would approve except for one issue.  I cannot approve this package until either python2-devel is added to the build requires or there is a change in policy from the python sig.
Comment 8 Mark McLoughlin 2011-08-22 12:33:06 EDT
Steven - okay, consider BR: python2-devel added. I'll do it before importing

I might remove it again later based on python SIG feedback, but there's no need to block on it
Comment 9 Steven Dake 2011-08-22 12:47:52 EDT
Mark,

When you post a new build + spec file with the change, I'll change to fedora-review+ with list of outstanding bugzilla issues that should be filed against component.

Regards
-steve
Comment 10 Mark McLoughlin 2011-08-22 13:12:33 EDT
Spec:

https://raw.github.com/markmc/openstack-fedora-specs/c2cc11a/SPECS/openstack-glance.spec

bzs from https://fedoraproject.org/wiki/OpenStack:

# uidgid reservation for swift, glance and nova
# logrotate config for glance
# no-manual-page-for-binary warnings
# Switch from sysvinit scripts to systemd units
# File bugs with upstream requesting that releases include a license file in their distributions
Comment 11 Steven Dake 2011-08-22 13:16:42 EDT
Package passes review.  Applying fedora-review+.
Comment 12 Mark McLoughlin 2011-08-22 13:22:11 EDT
Thanks again Steven

New Package SCM Request
=======================
Package Name: openstack-glance
Short Description: OpenStack Image Service
Owners: markmc
Branches: f16
InitialCC:
Comment 13 Jon Ciesla 2011-08-22 14:30:16 EDT
Git done (by process-git-requests).
Comment 14 Mark McLoughlin 2011-08-23 03:34:02 EDT
Built now in rawhide and f16
Comment 15 Matt Domsch 2011-08-29 12:39:31 EDT
New Package SCM Request
=======================
Package Name: openstack-glance
Short Description: OpenStack Image Service
Owners: markmc mdomsch
Branches: el6
InitialCC:
Comment 16 Jon Ciesla 2011-08-29 12:52:13 EDT
Please resubmit SCM request as a Change, since it now exists.

Thanks!
Comment 17 Matt Domsch 2011-08-29 12:56:09 EDT
Package Change Request
======================
Package Name: openstack-glance
New Branches: el6
Owners: markmc mdomsch
InitialCC:
Comment 18 Jon Ciesla 2011-08-29 13:00:56 EDT
Git done (by process-git-requests).
Comment 19 Steven Dake 2012-01-01 13:16:26 EST
Mark,

Taking ownership of this bug.  The person that completed the review should be the owner of the bug per fedora guidelines.

Thanks
-steve

Note You need to log in before you can comment on or make changes to this bug.